import 'package:mfsdk/utils/APPCONST.dart';

class MFCardInfo {
  String paymentType;
  bool saveToken;
  bool isRecurring;
  int intervalDays;
  Card card;
  String token;
  bool bypass3DS;

//  MFCardInfo(
//      {this.paymentType,
//        this.saveToken,
//        this.isRecurring,
//        this.intervalDays,
//        this.card,
//        this.token,
//        this.bypass3DS});

  MFCardInfo(String number, String expiryMonth, String expiryYear,
      String securityCode, {bool bypass3DS, bool saveToken}) {
    this.paymentType = APPCONST.KEY_CARD;
    this.card = new Card(number, expiryMonth, expiryYear, securityCode);
    this.saveToken = saveToken;
    this.bypass3DS = bypass3DS;
  }

  MFCardInfo.fromJson(Map<String, dynamic> json) {
    paymentType = json['PaymentType'];
    saveToken = json['SaveToken'] == 'true';
    isRecurring = json['IsRecurring'] == 'true';
    intervalDays = json['IntervalDays'];
    card = json['Card'] != null ? new Card.fromJson(json['Card']) : null;
    token = json['Token'];
    bypass3DS = json['Bypass3DS'] == 'true';
  }

  Map<String, Object> toJson() {
    final Map<String, Object> data = new Map<String, Object>();
    if(this.paymentType != null) data['PaymentType'] = this.paymentType;
    if(this.saveToken != null) data['SaveToken'] = this.saveToken.toString();
    if(this.isRecurring != null) data['IsRecurring'] = this.isRecurring.toString();
    if(this.intervalDays != null) data['IntervalDays'] = this.intervalDays;
    if (this.card != null) {
      data['Card'] = this.card.toJson();
    }
    if(this.token != null) data['Token'] = this.token;
    if(this.bypass3DS != null) data['Bypass3DS'] = this.bypass3DS.toString();
    return data;
  }
}

class Card {
  String number;
  String expiryMonth;
  String expiryYear;
  String securityCode;

  Card(this.number, this.expiryMonth, this.expiryYear, this.securityCode){
    this.number = number;
    this.expiryMonth = expiryMonth;
    this.expiryYear = expiryYear;
    this.securityCode = securityCode;
  }

  Card.fromJson(Map<String, dynamic> json) {
    number = json['Number'];
    expiryMonth = json['ExpiryMonth'];
    expiryYear = json['ExpiryYear'];
    securityCode = json['SecurityCode'];
  }

  toMap() {
    return {
      "Number": this.number,
      "ExpiryMonth": this.expiryMonth,
      "ExpiryYear": this.expiryYear,
      "SecurityCode": this.securityCode
    };
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['Number'] = this.number;
    data['ExpiryMonth'] = this.expiryMonth;
    data['ExpiryYear'] = this.expiryYear;
    data['SecurityCode'] = this.securityCode;
    return data;
  }
}
