class SDKDirectPaymentResponse {
  Data data;

  SDKDirectPaymentResponse({this.data});

  SDKDirectPaymentResponse.fromJson(Map<String, dynamic> json) {
    data = json['Data'] != null ? new Data.fromJson(json['Data']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.data != null) {
      data['Data'] = this.data.toJson();
    }
    return data;
  }
}

class Data {
  String status;
  String errorMessage;
  String paymentId;
  String token;
  String recurringId;
  String paymentURL;
  CardInfo cardInfo;

  Data(
      {this.status,
        this.errorMessage,
        this.paymentId,
        this.token,
        this.recurringId,
        this.paymentURL,
        this.cardInfo});

  Data.fromJson(Map<String, dynamic> json) {
    status = json['Status'];
    errorMessage = json['ErrorMessage'];
    paymentId = json['PaymentId'];
    token = json['Token'];
    recurringId = json['RecurringId'];
    paymentURL = json['PaymentURL'];
    cardInfo = json['CardInfo'] != null
        ? new CardInfo.fromJson(json['CardInfo'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['Status'] = this.status;
    data['ErrorMessage'] = this.errorMessage;
    data['PaymentId'] = this.paymentId;
    data['Token'] = this.token;
    data['RecurringId'] = this.recurringId;
    data['PaymentURL'] = this.paymentURL;
    if (this.cardInfo != null) {
      data['CardInfo'] = this.cardInfo.toJson();
    }
    return data;
  }
}

class CardInfo {
  String number;
  String expiryMonth;
  String expiryYear;
  String brand;
  String issuer;

  CardInfo(
      {this.number,
        this.expiryMonth,
        this.expiryYear,
        this.brand,
        this.issuer});

  CardInfo.fromJson(Map<String, dynamic> json) {
    number = json['Number'];
    expiryMonth = json['ExpiryMonth'];
    expiryYear = json['ExpiryYear'];
    brand = json['Brand'];
    issuer = json['Issuer'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['Number'] = this.number;
    data['ExpiryMonth'] = this.expiryMonth;
    data['ExpiryYear'] = this.expiryYear;
    data['Brand'] = this.brand;
    data['Issuer'] = this.issuer;
    return data;
  }
}
