import 'package:mfsdk/model/MFError.dart';

//class MFResult<T> {
//  MFResult._();
//
//  factory MFResult.success(T response) = Success<T>;
//  factory MFResult.fail(MFError error) = Fail<T>;
//}
//
//class Success<T> extends MFResult<T> {
//  Success(this.response): super._();
//
//   final T response;
//
//}
//
//class Fail<T> extends MFResult<T> {
//  Fail(this.error): super._();
//
//  final MFError error;
//}


class MFResult<T, ErrorType> {
  Status status ;
  T response ;
  ErrorType error ;

  MFResult(Status status, T response, ErrorType error) {
    this.status = status;
    this.response = response;
    this.error = error;
  }

  static MFResult<T, ErrorType> success<T, ErrorType>(T response) {
    return new MFResult<T, ErrorType>(Status.SUCCESS, response, null);
  }

  static MFResult<T, ErrorType> fail<T, ErrorType>(ErrorType error) {
    return new MFResult<T, ErrorType>(Status.ERROR, null, error);
  }

  bool isSuccess() {
    return status == Status.SUCCESS && response != null;
  }
}

enum Status {
  SUCCESS,
  ERROR
}